const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const booking_guests = sequelize.define(
    'booking_guests',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

guest_role: {
        type: DataTypes.ENUM,
      
      

        values: [

"primary",


"adult",


"child"

        ],

      },

is_payer: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  booking_guests.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






























//end loop



    db.booking_guests.belongsTo(db.bookings, {
      as: 'booking',
      foreignKey: {
        name: 'bookingId',
      },
      constraints: false,
    });

    db.booking_guests.belongsTo(db.guests, {
      as: 'guest',
      foreignKey: {
        name: 'guestId',
      },
      constraints: false,
    });




    db.booking_guests.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.booking_guests.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return booking_guests;
};


